//script to install the backported Scipad to BUILD_4 family Scilabs
// more precisely this is tested with:
//    - Scilab 4.1 binary version on Windows
//    - Scilab 4.1 source version on Linux
//    - Scilab 4.1 binary version on Linux
// and is supposed works on other 4.x unstables and other platforms 
//  as well, though untested.
// exec this script after having unzipped IN THE SCI DIRECTORY
//  the package provided
//////////////////////////////////////////////////////

//update the lib including the new .sci files
// can report that utillib is protected and won't be
// loaded in the current session; never mind
if find(string(utillib)=="FormatWhereForWatch")<>[] then
  warning(" utillib already contains the patched functions: perhaps")
  warning("  the patch has already been installed, but I''ll generate")
  warning("  utillib again for good")
  disp("")
end        
genlib("utillib");


//clean up unnecessary leftovers from the old version
scipaddir=SCI+"/tcl/scipadsources/";
filestodelete=scipaddir+["FormatWhereForDebugWatch.sci"
                         "FormatStringsForDebugWatch.sci"
                         "ext_exists.sci"
                         "bindings.tcl"
                         "CHANGELOG"];
leftoversExist=%t;
for i=1:size(filestodelete,1); 
  leftoversExist=leftoversExist & (fileinfo(filestodelete(i))<>[]); 
end

if leftoversExist then
  for i=1:size(filestodelete,1); mdelete(filestodelete(i)); end
else
  warning(" There are no old files to delete, maybe the patch has already")
  warning("  been installed?")
  disp("")
end

//that's it, see you in the next session

mprintf("Patch terminated, the new Scipad will be available from the"+..
        " next session on\n")
disp("   Press any key to quit scilab") 
halt
quit

